Status: Accepted Priority: Should have
Author: Stefan Neufeind Category: Code Cleanup
TYPO3 Version: 7
Complexity:
Sprint Focus:
Subject: Deprecate usage of GeneralUtility::isFirstPartOfStr()
Description

Use StringUtility::beginsWith() instead, which behaves "almost" identical but with some added checks.

Related issues:
related to Core - Task # 54517: Replace substr() and strpos() with GeneralUti... Accepted 2013-12-19

History
#1 - 2014-12-16 14:05 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35513

#2 - 2015-01-26 14:59 - Anja Leichsenring
- Sprint Focus set to On Location Sprint

#3 - 2015-01-31 15:00 - Benjamin Mack
- Status changed from Under Review to Accepted
- Target version set to 7.5

The proper solution here is to get rid of isFirstPartOfStr by applying the following logic:
The following 'rules' should used for the replacement:
    -  Drop isFirstPartOfStr / StringUtility::beginsWith in favor of any occurence of

  strpos(haystack, needle) === 0
  strpos(haystack, needle, 0) === 0

    -  Drop isFirstPartOfStr / StringUtility::beginsWith in favor of any occurence of
  substr(haystack, 0, strlen(needle)) === needle

    -  Use variable{x} for any occurence of
  substr(string, x, 1)

    -  Use array methods, when the string methods are simulating
  an explode or check substr with the third parameter set to TRUE

Once all places are replaced (see related issue), then we can proceed here.

#4 - 2015-01-31 17:35 - Stefan Neufeind
http://review.typo3.org/35513


Note that substr($s, 0, 1), in case of NULL or an empty string, will return false - while simply accessing the index would at least trigger a notice.
beginsWith handles some edge-cases as well.

#5 - 2015-01-31 18:35 - Jo Hasenau

So let's check for NULL and '' in these cases, to avoid the warning, since they are rare compared to the first example anyway.

#6 - 2015-01-31 19:10 - Benjamin Mack
- Sprint Focus deleted (On Location Sprint)
